#include "repeater.h"
#include <asm/div64.h>

ssize_t repeater_read(struct file *filp, char __user *buff, size_t count, loff_t *offp){
	int apos;
	loff_t no;
	struct repeater_dev *dev = filp -> private_data;

	if(down_interruptible(&dev->sem))
		return -ERESTARTSYS;

	if(dev->size == 0){
		up(&dev->sem);
		return 0;
	}

	no = *offp;

	apos = do_div(no,dev->size);
	if(apos + count >= dev->size)
		count = dev->size - apos;
	
	if(copy_to_user(buff, &(dev->toRepeat[apos]),count)){
		up(&dev->sem);
		return -EFAULT;
	}
	*offp += count;

	up(&dev->sem);	
	return count;
}
