#include "repeater.h"

ssize_t repeater_write(struct file *filp, const char __user *buff, size_t count, loff_t *offp){	
	int pos;
	struct repeater_dev *dev = filp -> private_data;

	if(down_interruptible(&dev->sem))
		return -ERESTARTSYS;
	if(*offp >= MAX_SIZE){
		up(&dev->sem);
		return 0;
	}
	if(*offp + count > MAX_SIZE)
		count = MAX_SIZE - *offp; 
	pos= (int) *offp;
	if(copy_from_user( &(dev->toRepeat[pos]),buff,count)){
		up(&dev->sem);
		return -EFAULT;
	}
	*offp +=count;
	pos+=count;
	if(dev->size < pos)
		dev->size = pos;
	
	up(&dev->sem);
	return count;
}
